<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		occle
 */

class Hook_ban_member
{
	/**
	 * Standard modular run function for OcCLE hooks.
	 *
	 * @param  array	The options with which the command was called
	 * @param  array	The parameters with which the command was called
	 * @param  array	A reference to the OcCLE filesystem object
	 * @return ~array  Array of stdcommand, stdhtml, stdout, and stderr responses (false: error)
	 */
	function run($options,$parameters,&$occle_fs)
	{
		if ((array_key_exists('h',$options)) || (array_key_exists('help',$options))) return array('',do_command_help('ban_member',array('h','u'),array(true,true)),'','');
		else
		{
			if (get_forum_type()!='ocf') return array('','','',do_lang('NO_OCF'));

			if (!array_key_exists(0,$parameters)) return array('','','',do_lang('MISSING_PARAM','1','ban_member'));

			require_code('ocf_members_action');
			require_code('ocf_members_action2');
			require_lang('ocf');

			if (is_numeric($parameters[0])) $member_id=$parameters[0];
			else $member_id=$GLOBALS['FORUM_DRIVER']->get_member_from_username($parameters[0]);

			if (is_null($member_id)) return array('','','',do_lang('USER_NO_EXIST'));

			if ((array_key_exists('u',$options)) || (array_key_exists('unban',$options))) ocf_unban_member($member_id);
			else ocf_ban_member($member_id);
			return array('','',do_lang('SUCCESS'),'');
		}
	}

}

