<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		authors
 */

class Hook_awards_author
{

	/**
	 * Standard modular info function for award hooks. Provides information to allow task reporting, randomisation, and add-screen linking, to function.
	 *
	 * @return ?array	Map of award content-type info (NULL: disabled).
	 */
	function info()
	{
		$info=array();
		$info['connection']=$GLOBALS['SITE_DB'];
		$info['table']='authors';
		$info['date_field']=NULL;
		$info['id_field']='author';
		$info['add_url']=(has_submit_permission('mid',get_member(),get_ip_address(),'cms_authors'))?build_url(array('page'=>'cms_authors','type'=>'_ad'),get_module_zone('cms_authors')):new ocp_tempcode();
		$info['category_field']=NULL;
		$info['submitter_field']='forum_handle';
		$info['id_is_string']=true;
		require_lang('authors');
		$info['title']=do_lang_tempcode('AUTHORS');
		$info['category_is_string']=true;
		$info['archive_url']=build_url(array('page'=>'authors'),get_module_zone('authors'));
		$info['cms_page']='cms_authors';
		$info['supports_custom_fields']=true;

		return $info;
	}

	/**
	 * Standard modular run function for award hooks. Renders a content box for an award/randomisation.
	 *
	 * @param  array		The database row for the content
	 * @param  ID_TEXT	The zone to display in
	 * @return tempcode	Results
	 */
	function run($row,$zone)
	{
		$url=build_url(array('page'=>'authors','type'=>'misc','id'=>$row['author']),$zone);

		return do_template('SIMPLE_PREVIEW_BOX',array('TITLE'=>$row['author'],'SUMMARY'=>get_translated_tempcode($row['description']),'URL'=>$url));
	}

}


