<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		cedi
 */

class Hook_content_meta_aware_cedi_post
{

	/**
	 * Standard modular info function for content_meta_aware hooks. Allows progmattic identification of ocPortal entity model (along with db_meta table contents).
	 *
	 * @return ?array	Map of award content-type info (NULL: disabled).
	 */
	function info()
	{
		return array(
			'content_type_label'=>'cedi:CEDI_POST',

			'table'=>'seedy_posts',
			'id_field'=>'id',
			'id_field_numeric'=>true,
			'parent_category_field'=>'page_id',
			'parent_category_meta_aware_type'=>'cedi_page',
			'title_field'=>NULL,
			'title_field_dereference'=>NULL,

			'is_category'=>false,
			'is_entry'=>true,
			'seo_type_code'=>NULL,
			'feedback_type_code'=>NULL,
			'permissions_type_code'=>NULL, // NULL if has no permissions
			'view_pagelink_pattern'=>'_SEARCH:cedi:find_post:_WILD',
			'edit_pagelink_pattern'=>'_SEARCH:cedi:post:post_id=_WILD',
			'view_category_pagelink_pattern'=>'_SEARCH:cedi:misc:_WILD',
			'support_url_monikers'=>false,
			'search_hook'=>'cedi_posts',
			'views_field'=>'seedy_views',
			'submitter_field'=>'the_user',
			'add_time_field'=>'date_and_time',
			'edit_time_field'=>'edit_date',
			'validated_field'=>'validated',

			'addon_name'=>'cedi',

			'module'=>'cedi',
		);
	}

}
